//---------------------------------------------------------------------------
#define MAXNUMBER 255
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TCheckBox *CheckBox[MAXNUMBER];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  Panel2->Left=150;
  Panel2->Top=120;
  CurrentDev=-1;  // -1 -     
  //    dll- -  
  if(Dll) FreeLibrary(Dll);
  Dll = LoadLibrary("rh0004.dll");
  if(Dll) //  Dll 
  {     //---    ConnectPort ---
        ConnectPort = (CPFunction *)GetProcAddress(Dll,"_ConnectPort");
        if(!ConnectPort)
        {       ShowMessage("     ConnectPort!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    DisconnectPort ---
        DisconnectPort = (DPFunction *)GetProcAddress(Dll,"_DisconnectPort");
        if(!DisconnectPort)
        {       ShowMessage("     DisconnectPort!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    ResetDevice ---
        ResetDevice = (UCHBFunction *)GetProcAddress(Dll,"_ResetDevice");
        if(!ResetDevice)
        {       ShowMessage("     ResetDevice!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    InterfaceChoice1W ---
        InterfaceChoice1W = (UCHBFunction *)GetProcAddress(Dll,"_InterfaceChoice1W");
        if(!InterfaceChoice1W)
        {       ShowMessage("     InterfaceChoise1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    ReadVersion ---
        ReadVersion = (UCHFunction *)GetProcAddress(Dll,"_ReadVersion");
        if(!ReadVersion)
        {       ShowMessage("     ReadVersion!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    SendReset_1W ---
        SendReset_1W = (UCHBFunction *)GetProcAddress(Dll,"_SendReset_1W");
        if(!SendReset_1W)
        {       ShowMessage("     SendReset_1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    SendByte_1W ---
        SendByte_1W = (UIHBUCFunction *)GetProcAddress(Dll,"_SendByte_1W");
        if(!SendByte_1W)
        {       ShowMessage("     SendByte_1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    ReadByte_1W ---
        ReadByte_1W = (RHFunction *)GetProcAddress(Dll,"_ReadByte_1W");
        if(!ReadByte_1W)
        {       ShowMessage("     ReadByte_1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    SendBit_1W ---
        SendBit_1W = (UIHBUCFunction *)GetProcAddress(Dll,"_SendBit_1W");
        if(!SendBit_1W)
        {       ShowMessage("     SendBit_1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    ReadBit_1W ---
        ReadBit_1W = (UCHFunction *)GetProcAddress(Dll,"_ReadBit_1W");
        if(!ReadBit_1W)
        {       ShowMessage("     ReadBit_1W!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    DisableReports ---
        DisableReports = (UCHFunction *)GetProcAddress(Dll,"_DisableReports");
        if(!DisableReports)
        {       ShowMessage("     DisableReports!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //*****    IO *****
        //---    IO0ConfigOutput ---
        IO0ConfigOutput = (UCHBFunction *)GetProcAddress(Dll,"_IO0ConfigOutput");
        if(!IO0ConfigOutput)
        {       ShowMessage("     IO0ConfigOutput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO0ConfigInput ---
        IO0ConfigInput = (UCHBFunction *)GetProcAddress(Dll,"_IO0ConfigInput");
        if(!IO0ConfigInput)
        {       ShowMessage("     IO0ConfigInput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO0Output0 ---
        IO0Output0 = (UCHBFunction *)GetProcAddress(Dll,"_IO0Output0");
        if(!IO0Output0)
        {       ShowMessage("     IO0Output0!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO0Output1 ---
        IO0Output1 = (UCHBFunction *)GetProcAddress(Dll,"_IO0Output1");
        if(!IO0Output1)
        {       ShowMessage("     IO0Output1!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO1ConfigOutput ---
        IO1ConfigOutput = (UCHBFunction *)GetProcAddress(Dll,"_IO1ConfigOutput");
        if(!IO1ConfigOutput)
        {       ShowMessage("     IO1ConfigOutput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO1ConfigInput ---
        IO1ConfigInput = (UCHBFunction *)GetProcAddress(Dll,"_IO1ConfigInput");
        if(!IO1ConfigInput)
        {       ShowMessage("     IO1ConfigInput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO1Output0 ---
        IO1Output0 = (UCHBFunction *)GetProcAddress(Dll,"_IO1Output0");
        if(!IO1Output0)
        {       ShowMessage("     IO1Output0!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO1Output1 ---
        IO1Output1 = (UCHBFunction *)GetProcAddress(Dll,"_IO1Output1");
        if(!IO0Output1)
        {       ShowMessage("     IO1Output1!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO2ConfigOutput ---
        IO2ConfigOutput = (UCHBFunction *)GetProcAddress(Dll,"_IO2ConfigOutput");
        if(!IO2ConfigOutput)
        {       ShowMessage("     IO2ConfigOutput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO2ConfigInput ---
        IO2ConfigInput = (UCHBFunction *)GetProcAddress(Dll,"_IO2ConfigInput");
        if(!IO2ConfigInput)
        {       ShowMessage("     IO2ConfigInput!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO2Output0 ---
        IO2Output0 = (UCHBFunction *)GetProcAddress(Dll,"_IO2Output0");
        if(!IO2Output0)
        {       ShowMessage("     IO2Output0!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    IO2Output1 ---
        IO2Output1 = (UCHBFunction *)GetProcAddress(Dll,"_IO2Output1");
        if(!IO2Output1)
        {       ShowMessage("     IO2Output1!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    TestIO_0 ---
        TestIO_0 = (UCHFunction *)GetProcAddress(Dll,"_TestIO_0");
        if(!TestIO_0)
        {       ShowMessage("     TestIO_0!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    TestIO_1 ---
        TestIO_1 = (UCHFunction *)GetProcAddress(Dll,"_TestIO_1");
        if(!TestIO_1)
        {       ShowMessage("     TestIO_1!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //---    TestIO_2 ---
        TestIO_2 = (UCHFunction *)GetProcAddress(Dll,"_TestIO_2");
        if(!TestIO_2)
        {       ShowMessage("     TestIO_2!");
                FreeLibrary(Dll);
                exit(EXIT_FAILURE);
        }
        //ShowMessage("Dll  ,      !");
        //    
        StringGrid1->Cells[0][0]="Index";
        StringGrid1->Cells[1][0]="ROM Number";
        StringGrid1->Cells[2][0]="Scan";
        StringGrid1->Cells[3][0]="Value";
        StringGrid1->Cells[4][0]="Tag";
        //    I/O
        StringGrid2->Cells[0][0]="Tag";
        StringGrid2->Cells[1][0]="Configuration";
        StringGrid2->Cells[2][0]="Value";
        StringGrid2->Cells[0][1]="io0";
        StringGrid2->Cells[1][1]="No data";
        StringGrid2->Cells[2][1]="No data";
        StringGrid2->Cells[0][2]="io1";
        StringGrid2->Cells[1][2]="No data";
        StringGrid2->Cells[2][2]="No data";
        StringGrid2->Cells[0][3]="io2";
        StringGrid2->Cells[1][3]="No data";
        StringGrid2->Cells[2][3]="No data";

        Dev=0;  //   
        
        if(FileExists("shablon.html"))	//    
        {	Memo1->Lines->Clear();
	        Memo1->Lines->LoadFromFile("shablon.html"); //    Memo
        	Shablon=Memo1->Text;    //     Shablon
        }
        else                            //     -    
        {       Shablon="<html><body><p>Not found shablon.html</p></body></html>";
        }
        return; //   ,    
  }
  else  ShowMessage("   rh0004.dll");
  exit(EXIT_FAILURE);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ Port=ConnectPort(ComboBox1->Text.c_str());
  if(Port!=INVALID_HANDLE_VALUE)
  {     Button1->Enabled=false;
        Button2->Enabled=true;
        //  
        if(DisableReports(Port)!=0) ShowMessage("   !");
        //  
        if(ResetDevice(Port,false)!=0) ShowMessage("   !");
        //  1W
        if(InterfaceChoice1W(Port,false)!=0) ShowMessage("   !");
  }
  else  ShowMessage("   !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ HANDLE Temp;
  Temp=DisconnectPort(Port);
  Port=Temp;
  if(Port==INVALID_HANDLE_VALUE)
  {     Button1->Enabled=true;
        Button2->Enabled=false;
  }
  else ShowMessage("   !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Firmware1Click(TObject *Sender)
{ unsigned char Temp;
  if(Port!=INVALID_HANDLE_VALUE)
  {     Temp=ReadVersion(Port);
        if(Temp==0xFF)        ShowMessage(" WriteError!");
        else if(Temp==0xFE)   ShowMessage(" ReadError!");
        else                  ShowMessage(("  : "+IntToStr(Temp)).c_str());
  }
  else  ShowMessage("   !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{ if(Dev>0)     //   - 
  {     //  ,     
        int i=0;
        while(i<(StringGrid1->TopRow - 1))
        {       if(i<Dev)       CheckBox[i]->Visible=false;  // if          
                i=i+1;                                       //  (  ,      )
        }
        i=StringGrid1->TopRow + StringGrid1->VisibleRowCount;
        while(i<Dev)
        {       CheckBox[i]->Visible=false;
                i=i+1;
        }
        //  ,     CheckBox
        if(ARow>0 && ARow<(Dev+1) && ACol==2) // CheckBox-     (  )
        {       CheckBox[ARow-1]->Left = StringGrid1->Left+Rect.Left+2;
                CheckBox[ARow-1]->Top = StringGrid1->Top+Rect.Top+2;
                CheckBox[ARow-1]->Width = Rect.Width();
                CheckBox[ARow-1]->Height = Rect.Height();
                CheckBox[ARow-1]->Visible=true;
        }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ //SEARCH DEVICES
  unsigned char CRC, ROM[8], Poly, Temp, MasterBit, RBTemp;
  char buf[2], value[1], hexbuf[3];
  bool SlaveBit, ISlaveBit, LastDev;
  int Step, LastFork, ZeroFork, CurrentByte, CurrentBit;
  AnsiString TempStr;

  Timer1->Enabled=false;
  //  
  if(Dev>0)                             //  
        for(int j=0; j<Dev; j++)        //   
                CheckBox[j]->Free();

  //
  Poly=0x31; Dev=0;
  StringGrid1->RowCount=Dev+2; //    
  StringGrid1->Cells[0][1]="";
  StringGrid1->Cells[1][1]="";

  for(int i=0; i<8; i++)
  { ROM[i]=0; }  //  ROM
  LastDev=false;
  LastFork=-1;

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  while(!LastDev) //     
  {     CRC=0; ZeroFork=-1; Step=0;
        // Reset
        SendReset_1W(Port,false);
        ::Sleep(1);
        // Search ROM
        SendByte_1W(Port,false,0xF0);
        ::Sleep(1);
        while(Step<64) //       (64 )
        {       CurrentByte=Step/8; CurrentBit=Step-8*CurrentByte;
                //    
                RBTemp=ReadBit_1W(Port);
                if(RBTemp==0)  SlaveBit=false;
                else           SlaveBit=true;
                //    
                RBTemp=ReadBit_1W(Port);
                if(RBTemp==0)  ISlaveBit=false;
                else           ISlaveBit=true;
                //    ?
                if(SlaveBit==ISlaveBit)  //   -   
                {       if (SlaveBit)   //  SlaveBit=1 ()
                        {      MessageBox(NULL,",     ","Error",MB_OK);
                               LBar->Free();        //    -
                               Timer1->Enabled=true;
                               return;
                        }
                        else    //  SlaveBit=0 ()
                        {       if(Step==LastFork)
                                { MasterBit=1; }     // MasterBit=1
                                else
                                {       if(Step>LastFork)
                                        { MasterBit=0; }
                                        else
                                        { MasterBit=ROM[CurrentByte]>>CurrentBit; }
                                        if((MasterBit&1)==0)    //  MasterBit=0
                                        { ZeroFork=Step; }
                                }
                        }
                }
                else //    (  )
                { MasterBit=SlaveBit; }  // MasterBit=SlaveBit

                //    ROM
                Temp=1<<CurrentBit;                     //  =1
                Temp=~Temp;                             // 
                ROM[CurrentByte]=ROM[CurrentByte]&Temp; //   
                Temp=(MasterBit&1)<<CurrentBit;         //  =MasterBit
                ROM[CurrentByte]=ROM[CurrentByte]|Temp; //  MasterBit
                // CRC
                Temp=CRC&0x80; //  
                CRC<<1;        //  CRC 
                if(Temp)       //   =1
                        CRC=CRC^Poly;
                //   
                SendBit_1W(Port,false,MasterBit);
                ::Sleep(1);
                Step=Step+1;
                LBar->ProgressBar1->Position=100*Step/64; //    -
        }
        //   
        LastFork=ZeroFork;
        if(LastFork<0)
                LastDev=true;
        if(CRC==0)
        {       Dev=Dev+1;            //    
                StringGrid1->RowCount=Dev+1;      //    
                CheckBox[Dev-1]=new TCheckBox(Application);  //   CheckBox
                CheckBox[Dev-1]->Visible=false;
                CheckBox[Dev-1]->Checked=false;
                CheckBox[Dev-1]->Enabled=true;
                CheckBox[Dev-1]->Parent=Panel1;
                TempStr="";
                for(int i=0; i<8; i++)
                {       value[0]=ROM[i];
                        BinToHex(value,hexbuf,1);       //   
                        hexbuf[2]=0;                    //   
                        TempStr=TempStr+hexbuf+" ";
                }
                StringGrid1->Cells[0][Dev]=IntToStr(Dev);
                StringGrid1->Cells[1][Dev]=TempStr;

                //   
                StringGrid1->Cells[4][Dev]="TE"+IntToStr(Dev);
                //    html-
                int TempPos=Shablon.Pos("</table></body>"); //    
                //        
                Shablon.Insert("<tr><td>TE"+IntToStr(Dev)+"</td><td id=TE"+IntToStr(Dev)+"></td></tr>",TempPos);
        }
        else
        {       MessageBox(NULL," CRC","Error",MB_OK);
                LBar->Free();        //    -
                Timer1->Enabled=true;
                return;
        }
  }
  LBar->Free();        //    -
  Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{ int ACol, ARow;
  StringGrid1->MouseToCell(MousePos.x,MousePos.y,ACol,ARow);
  ARowClick=ARow;
  if(ARow>0 && Dev>0) //       
        PopupMenu1->Popup(Left+StringGrid1->Left+Panel1->Left+MousePos.x+8,Top+Panel1->Top+StringGrid1->Top+MousePos.y+18);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AddTag1Click(TObject *Sender)
{ Panel2->Enabled=true;
  Panel2->Visible=true;
  Edit1->Clear();
  Edit1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ Panel2->Visible=false;
  Panel2->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ AnsiString TempStr;
  int TempDl, TempPos;
  TempStr=StringGrid1->Cells[4][ARowClick]; //    
  TempDl=TempStr.Length(); //   
  TempPos=Shablon.Pos(TempStr); //     
  Shablon.Delete(TempPos,TempDl); //  
  Shablon.Insert(Edit1->Text,TempPos); //    

  StringGrid1->Cells[4][ARowClick]=Edit1->Text;
  Panel2->Visible=false;
  Panel2->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ AnsiString TempStr;
  char buf[2], value[1];
  Result TempRes;       //    
  float Temp;           //     
  unsigned char TestRes;//    

  if(Port!=INVALID_HANDLE_VALUE)
  {     Timer1->Enabled=false;  //  

        //      ( )
        if(IO0Set0==true)       IO0Output0(Port,false);
        if(IO0Set1==true)       IO0Output1(Port,false);
        if(IO1Set0==true)       IO1Output0(Port,false);
        if(IO1Set1==true)       IO1Output1(Port,false);
        if(IO2Set0==true)       IO2Output0(Port,false);
        if(IO2Set1==true)       IO2Output1(Port,false);
        //      ( )
        if(IO0SwIn==true)
        {       TestRes=IO0ConfigInput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][1]="Input";
                else            StringGrid2->Cells[1][1]="Unknown";
        }
        if(IO0SwOu==true)
        {       TestRes=IO0ConfigOutput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][1]="Output";
                else            StringGrid2->Cells[1][1]="Unknown";
        }
        if(IO1SwIn==true)
        {       TestRes=IO1ConfigInput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][2]="Input";
                else            StringGrid2->Cells[1][2]="Unknown";
        }
        if(IO1SwOu==true)
        {       TestRes=IO1ConfigOutput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][2]="Output";
                else            StringGrid2->Cells[1][2]="Unknown";
        }
        if(IO2SwIn==true)
        {       TestRes=IO2ConfigInput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][3]="Input";
                else            StringGrid2->Cells[1][3]="Unknown";
        }
        if(IO2SwOu==true)
        {       TestRes=IO2ConfigOutput(Port,false);     //     
                if(!TestRes)    StringGrid2->Cells[1][3]="Output";
                else            StringGrid2->Cells[1][3]="Unknown";
        }
        //  
        IO0Set0=false; IO0Set1=false;
        IO1Set0=false; IO1Set1=false;
        IO2Set0=false; IO2Set1=false;

        IO0SwIn=false; IO0SwOu=false;
        IO1SwIn=false; IO1SwOu=false;
        IO2SwIn=false; IO2SwOu=false;

        if(CurrentDev>=Dev) //   -    
                CurrentDev=-4;
        //     -4 -   I/O0
        if(CurrentDev==-4)
        {       TestRes=TestIO_0(Port); //   IO
                if(TestRes==1)          StringGrid2->Cells[2][1]="Hi";          //  
                else if(TestRes==0)     StringGrid2->Cells[2][1]="Low";         //  
                else                    StringGrid2->Cells[2][1]="Unknown";     //     
        }
        //     -3 -   I/O1
        if(CurrentDev==-3)
        {       TestRes=TestIO_1(Port); //   IO
                if(TestRes==1)          StringGrid2->Cells[2][2]="Hi";          //  
                else if(TestRes==0)     StringGrid2->Cells[2][2]="Low";         //  
                else                    StringGrid2->Cells[2][2]="Unknown";     //     
        }
        //     -2 -   I/O2
        if(CurrentDev==-2)
        {       TestRes=TestIO_2(Port); //   IO
                if(TestRes==1)          StringGrid2->Cells[2][3]="Hi";          //  
                else if(TestRes==0)     StringGrid2->Cells[2][3]="Low";         //  
                else                    StringGrid2->Cells[2][3]="Unknown";     //     
        }
        //     
        if(Dev>0 && CurrentDev>-2)
        {       //     -1 -    
                if(CurrentDev==-1)
                {       SendReset_1W(Port,false);       //  Reset
                        ::Sleep(1);
                        SendByte_1W(Port,false,0xCC);   // Skip ROM
                        SendByte_1W(Port,false,0x44);   // Convert
                }
                else //    
                {       if(CheckBox[CurrentDev]->Checked==true) //  Scan 
                        {       SendReset_1W(Port,false);       //  Reset
                                ::Sleep(1);
                                SendByte_1W(Port,false,0x55);   // Match ROM
                                for(int i=0; i<8; i++)
                                {       //     StringGrid1
                                        memset(buf,0,2);        //  
                                        TempStr=(StringGrid1->Cells[1][CurrentDev+1]).SubString(3*i+1,2);
                                        strcat(buf,TempStr.c_str());    //      (  )
                                        HexToBin(buf,value,1);  //    ()
                                        //   
                                        SendByte_1W(Port,false,value[0]);
                                }
                                //  
                                SendByte_1W(Port,false,0xBE); // Read Scratchpad
                                //   
                                TempRes=ReadByte_1W(Port);
                                if(TempRes.Size>0)
                                {       Byte0=TempRes.Buffer[0];
                                        //   
                                        TempRes=ReadByte_1W(Port);
                                        if(TempRes.Size>0)
                                        {       Byte1=TempRes.Buffer[0];
                                                Temp=64*((Byte1&4)>>2)+32*((Byte1&2)>>1)+16*(Byte1&1)+8*((Byte0&128)>>7)+4*((Byte0&64)>>6)+2*((Byte0&32)>>5)+1*((Byte0&16)>>4)+0.5*((Byte0&8)>>3)+0.25*((Byte0&4)>>2)+0.125*((Byte0&2)>>1)+0.0625*(Byte0&1);

                                                TVarRec vr[] = {Temp};
                                                TempStr=Format("%3.4f",vr,1);
                                                StringGrid1->Cells[3][CurrentDev+1]=TempStr;
                                        }
                                        else    StringGrid1->Cells[3][CurrentDev+1]="Error";
                                }
                                else    StringGrid1->Cells[3][CurrentDev+1]="Error";
                        }
                        else    StringGrid1->Cells[3][CurrentDev+1]="No data";
                }
        }
        CurrentDev=CurrentDev+1;
        Timer1->Enabled=true;   //  
  }
  else
  {     if(Dev>0)
        {       for(int j=0; j<Dev; j++)
                        StringGrid1->Cells[3][j+1]="No data";
        }
        CurrentDev=-1;
        //  
        StringGrid2->Cells[1][1]="No data";
        StringGrid2->Cells[2][1]="No data";
        StringGrid2->Cells[1][2]="No data";
        StringGrid2->Cells[2][2]="No data";
        StringGrid2->Cells[1][3]="No data";
        StringGrid2->Cells[2][3]="No data";
        //  
        IO0Set0=false; IO0Set1=false;
        IO1Set0=false; IO1Set1=false;
        IO2Set0=false; IO2Set1=false;

        IO0SwIn=false; IO0SwOu=false;
        IO1SwIn=false; IO1SwOu=false;
        IO2SwIn=false; IO2SwOu=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{ IO0SwIn=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{ IO0SwOu=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{ IO0Set1=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{ IO0Set0=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button12Click(TObject *Sender)
{ IO1SwIn=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
{ IO1SwOu=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button14Click(TObject *Sender)
{ IO1Set1=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
{ IO1Set0=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button16Click(TObject *Sender)
{ IO2SwIn=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button17Click(TObject *Sender)
{ IO2SwOu=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button18Click(TObject *Sender)
{ IO2Set1=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button19Click(TObject *Sender)
{ IO2Set0=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{  int TempPort;

   try  //     Edit2   
   {    TempPort=StrToInt(Edit2->Text);
   }
   catch (...)  //   
   {    ShowMessage("      0  65536");
        return;
   }
   if(TempPort<0 || TempPort>65536) //  ,   
   {    ShowMessage("      0  65536");
        return;
   }
   else
   {    IdHTTPServer1->DefaultPort=TempPort;    //   
        Button4->Enabled=false;                 //  "Start server"
        Button7->Enabled=true;                  //  "Stop server"
        IdHTTPServer1->Active=true;             //  
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{ Button4->Enabled=true;
  Button7->Enabled=false;
  IdHTTPServer1->Active=false;  //  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IdHTTPServer1CommandGet(TIdPeerThread *AThread,
      TIdHTTPRequestInfo *RequestInfo, TIdHTTPResponseInfo *ResponseInfo)
{ AnsiString    TempStr;

  if(RequestInfo->Document=="/" || RequestInfo->Document=="/index.html") //        index.html
  {     ResponseInfo->ResponseNo=200;           //   OK
        if(RequestInfo->Params->Count==0)       //    -   
        {       TempStr=Shablon;
        }
        else    //    -        
        {       TempStr=IntToStr(Dev); //   
                for(int i=0; i<RequestInfo->Params->Count; i++) //     
                {       if(RequestInfo->Params->Names[i]=="GetTemp") //      
                        {       if(Dev>0)       //   
                                {       for(int j=0; j<Dev; j++) //      ;
                                        {       TempStr=TempStr+";"+StringGrid1->Cells[4][j+1]+";"+StringGrid1->Cells[3][j+1];
                                        }
                                }
                        }
                        if(RequestInfo->Params->Names[i]=="GetIO") //      IO
                        {       for(int j=0; j<3; j++) //      ;
                                {       // 
                                        TempStr=TempStr+";"+StringGrid2->Cells[0][j+1]+"con;"+StringGrid2->Cells[1][j+1];
                                        // 
                                        TempStr=TempStr+";"+StringGrid2->Cells[0][j+1]+"val;"+StringGrid2->Cells[2][j+1];
                                }
                        }
                }
        }
        //  
        ResponseInfo->ContentText=TempStr;
  }
  else  ResponseInfo->ResponseNo=403;   //   Forbidden ( ,  )
}
//---------------------------------------------------------------------------

